<?php
/**
 * Author: topnuomi
 * Date: 2021/2/24 14:21
 */

namespace top\base\attributes;

/**
 * Class Attribute
 * @package top\base\attributes
 */
class Attribute
{
    /**
     * 传入的参数
     * @var mixed
     */
    private mixed $data;

    /**
     * Attribute constructor.
     * @param mixed ...$args
     */
    public function __construct(...$args)
    {
        $this->data = $args;
    }

    /**
     * 获取参数
     * @param int $index
     * @return mixed
     */
    public function getAttributeVar(int $index = 0): mixed
    {
        return $this->data[$index] ?? '';
    }

    /**
     * 获取注解名
     * @return string
     */
    public function getAttributeName(): string
    {
        return substr(static::class, strrpos(static::class, '\\') + 1);
    }
}
