<?php
/**
 * Author: topnuomi
 * Date: 2021/3/13 13:32
 */

namespace top\facade;

use Closure;
use top\base\Config;
use top\base\Container;
use top\base\Facade;
use top\base\Middleware;
use top\base\Request;
use top\base\Response;
use top\base\Route;

/**
 * Class Application
 * @property Attribute attribute
 * @property Application app
 * @property Config config
 * @property Route route
 * @property Request request
 * @property Response response
 * @property Middleware middleware
 * @method Application path(string $path = '')
 * @method Application name(string $name = '')
 * @method string boot()
 * @method static Container getInstance()
 * @method static static bind(string $name, callable|object|string $bind)
 * @method static static instance(string $name, object $bind)
 * @method string getAlias(string $name)
 * @method mixed make(string $name, array $args = [], bool $newInstance = false)
 * @method mixed invokeFunction(Closure $function, array $args = [])
 * @method mixed invokeMethod(string|object $className, string $methodName, array $args = [])
 * @package top\facade
 */
class Application extends Facade
{
    public static function getRepresentName(): string
    {
        return 'Application';
    }
}
